<template>
  <div id="home">
    <div class="mt-2 md:mt-8 lg:mt-16 max-w-xl mx-auto">
      <div class="bg-white p-8 shadow rounded-lg">
        <a href="#" class="float-right font-hairline top-0 right-0" @click.prevent="signOut">Sign Out</a>
        <br>
        <h1 class="text-3xl uppercase font-semibold tracking-wide text-center">
          Welcome To ToDos
        </h1>
        <div class="text-center m-2" @click="createListModal = true">
          <button type="button" class="px-4 py-2 bg-black text-white rounded-lg">
            <font-awesome-icon
                icon="plus"
                class="text-white"
            ></font-awesome-icon>
            <span class="font-semibold uppercase"> Add List</span>
          </button>
        </div>
        <custom-modal :showing="createListModal" @close="createListModal = false">
          <h2 class="text-center font-semibold uppercase text-lg">Create New List</h2>
          <form action="#" class="mt-5" @submit.prevent="createList">
            <div class="form-group mb-5">
              <input type="text" name="name" class="rounded w-full shadow p-2 border border-gray-900 tracking-wide text-lg" placeholder="Name" id="create-list-name" autocomplete="on" v-model="createListParams.name" autofocus>
            </div>
            <div class="text-center flex justify-between">
              <a href="#" @click.prevent="createListModal = false" class="self-center hover:underline hover:text-gray-800">Cancel</a>
              <button type="submit" class="px-4 py-2 rounded tracking-wide font-semibold bg-black text-white text-lg hover:bg-gray-800 shadow-lg">Create</button>
            </div>
          </form>
        </custom-modal>
        <div class="max-w-xl mx-auto">
          <router-link :to="{ name: 'ListShow', params: { listId: list.id }}" v-for="list in lists" :key="list.id" class="mb-2 p-2 pl-5 shadow font-semibold tracking-wide rounded-lg text-xl italic block">{{list.name}}</router-link>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
// @ is an alias to /src

import axios from "axios";
import CustomModal from '@/components/CustomModal.vue'

export default {
  name: 'Home',
  data() {
    return {
      currentUser: {},
      lists: [],
      createListModal: false,
      createListParams: {}
    }
  },
  components: {
    CustomModal
  },
  methods: {
    async checkUserLoggedIn() {
      if(localStorage.getItem('currentUser')!==undefined){
        try {
          let response = await axios.get("https://todo-api.spico.tech/api/auth/validate_token", {headers: {Authorization: JSON.parse(localStorage.getItem('currentUser')).Authorization}})
          localStorage.currentUser = JSON.stringify(response.data)
        } catch (err) {
          this.$router.push({name: 'SignIn'})
        }
      }
    },
    async getLists() {
      try {
        let response = await axios.get("https://todo-api.spico.tech/api/lists", {headers: {Authorization: this.currentUser.Authorization}})
        this.lists = response.data
      } catch (err) {}
    },
    async createList() {
      try {
        await axios.post("https://todo-api.spico.tech/api/lists", this.createListParams, {headers: {Authorization: this.currentUser.Authorization}})
        this.createListParams = {}
        this.getLists()
        this.createListModal = false
      } catch (err) {}
    },
    goToList(listId) {
      this.$router.push({name: 'ListShow', params: {listId}})
    },
    signOut() {
      localStorage.removeItem("currentUser")
      this.$router.push({name: 'SignIn'})
    }
  },
  mounted() {
    this.checkUserLoggedIn()
    this.currentUser = JSON.parse(localStorage.getItem('currentUser'))
    this.getLists()
  }
}
</script>
